<html>
<head>
<title>OgreShaderExLayeredBlending.h Source File - OGRE Documentation</title> <meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1"> 
<link type="text/css" rel="stylesheet" href="doxygen.css">
<link type="text/css" rel="stylesheet" href="tabs.css">
</head>

<body>
<!-- Generated by Doxygen 1.7.6.1 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.html"><span>Main&#160;Page</span></a></li>
      <li><a href="pages.html"><span>Related&#160;Pages</span></a></li>
      <li><a href="modules.html"><span>Modules</span></a></li>
      <li><a href="namespaces.html"><span>Namespaces</span></a></li>
      <li><a href="annotated.html"><span>Classes</span></a></li>
      <li class="current"><a href="files.html"><span>Files</span></a></li>
      <li><a href="dirs.html"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.html"><span>File&#160;List</span></a></li>
      <li><a href="globals.html"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_f1fa7196649e3987904dbdb4948bc856.html">Components</a>      </li>
      <li class="navelem"><a class="el" href="dir_1ff0a99c786b1c34b8d04ba7e7285590.html">RTShaderSystem</a>      </li>
      <li class="navelem"><a class="el" href="dir_167378df2bdccc9b313fc91c17987f1d.html">include</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">OgreShaderExLayeredBlending.h</div>  </div>
</div><!--header-->
<div class="contents">
<a href="OgreShaderExLayeredBlending_8h.html">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">/*</span>
<a name="l00002"></a>00002 <span class="comment">-----------------------------------------------------------------------------</span>
<a name="l00003"></a>00003 <span class="comment">This source file is part of OGRE</span>
<a name="l00004"></a>00004 <span class="comment">(Object-oriented Graphics Rendering Engine)</span>
<a name="l00005"></a>00005 <span class="comment">For the latest info, see http://www.ogre3d.org/</span>
<a name="l00006"></a>00006 <span class="comment"></span>
<a name="l00007"></a>00007 <span class="comment">Copyright (c) 2000-2012 Torus Knot Software Ltd</span>
<a name="l00008"></a>00008 <span class="comment"></span>
<a name="l00009"></a>00009 <span class="comment">Permission is hereby granted, free of charge, to any person obtaining a copy</span>
<a name="l00010"></a>00010 <span class="comment">of this software and associated documentation files (the &quot;Software&quot;), to deal</span>
<a name="l00011"></a>00011 <span class="comment">in the Software without restriction, including without limitation the rights</span>
<a name="l00012"></a>00012 <span class="comment">to use, copy, modify, merge, publish, distribute, sublicense, and/or sell</span>
<a name="l00013"></a>00013 <span class="comment">copies of the Software, and to permit persons to whom the Software is</span>
<a name="l00014"></a>00014 <span class="comment">furnished to do so, subject to the following conditions:</span>
<a name="l00015"></a>00015 <span class="comment"></span>
<a name="l00016"></a>00016 <span class="comment">The above copyright notice and this permission notice shall be included in</span>
<a name="l00017"></a>00017 <span class="comment">all copies or substantial portions of the Software.</span>
<a name="l00018"></a>00018 <span class="comment"></span>
<a name="l00019"></a>00019 <span class="comment">THE SOFTWARE IS PROVIDED &quot;AS IS&quot;, WITHOUT WARRANTY OF ANY KIND, EXPRESS OR</span>
<a name="l00020"></a>00020 <span class="comment">IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,</span>
<a name="l00021"></a>00021 <span class="comment">FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE</span>
<a name="l00022"></a>00022 <span class="comment">AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER</span>
<a name="l00023"></a>00023 <span class="comment">LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,</span>
<a name="l00024"></a>00024 <span class="comment">OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN</span>
<a name="l00025"></a>00025 <span class="comment">THE SOFTWARE.</span>
<a name="l00026"></a>00026 <span class="comment">-----------------------------------------------------------------------------</span>
<a name="l00027"></a>00027 <span class="comment">*/</span>
<a name="l00028"></a>00028 <span class="preprocessor">#ifndef _OgreShaderExLayeredBlending_</span>
<a name="l00029"></a>00029 <span class="preprocessor"></span><span class="preprocessor">#define _OgreShaderExLayeredBlending_</span>
<a name="l00030"></a>00030 <span class="preprocessor"></span>
<a name="l00031"></a>00031 <span class="preprocessor">#include &quot;<a class="code" href="OgreShaderPrerequisites_8h.html">OgreShaderPrerequisites.h</a>&quot;</span>
<a name="l00032"></a>00032 <span class="preprocessor">#ifdef RTSHADER_SYSTEM_BUILD_EXT_SHADERS</span>
<a name="l00033"></a>00033 <span class="preprocessor"></span><span class="preprocessor">#include &quot;<a class="code" href="OgreShaderFFPTexturing_8h.html">OgreShaderFFPTexturing.h</a>&quot;</span>
<a name="l00034"></a>00034 <span class="preprocessor">#include &quot;<a class="code" href="OgreShaderProgramSet_8h.html">OgreShaderProgramSet.h</a>&quot;</span>
<a name="l00035"></a>00035 <span class="preprocessor">#include &quot;<a class="code" href="OgreShaderParameter_8h.html">OgreShaderParameter.h</a>&quot;</span>
<a name="l00036"></a>00036 <span class="preprocessor">#include &quot;<a class="code" href="OgreShaderFunction_8h.html">OgreShaderFunction.h</a>&quot;</span>
<a name="l00037"></a>00037 <span class="preprocessor">#include &quot;<a class="code" href="OgreShaderSubRenderState_8h.html">OgreShaderSubRenderState.h</a>&quot;</span>
<a name="l00038"></a>00038 
<a name="l00039"></a>00039 <span class="keyword">namespace </span>Ogre {
<a name="l00040"></a>00040 <span class="keyword">namespace </span>RTShader {
<a name="l00041"></a>00041 
<a name="l00042"></a>00042 <span class="preprocessor">#define SGX_LIB_LAYEREDBLENDING     &quot;SGXLib_LayeredBlending&quot;</span>
<a name="l00043"></a>00043 <span class="preprocessor"></span>
<a name="l00047"></a>00047 <span class="keyword">class </span><a class="code" href="OgreShaderPrerequisites_8h.html#a2e7039d2e7e0e3a2feb2008cc7f4be43">_OgreRTSSExport</a> LayeredBlending : <span class="keyword">public</span> FFPTexturing
<a name="l00048"></a>00048 {
<a name="l00049"></a>00049 <span class="keyword">public</span>:
<a name="l00050"></a>00050     <span class="keyword">enum</span> BlendMode
<a name="l00051"></a>00051     {
<a name="l00052"></a>00052         LB_Invalid = -1,
<a name="l00053"></a>00053         LB_FFPBlend,
<a name="l00054"></a>00054         LB_BlendNormal,
<a name="l00055"></a>00055         LB_BlendLighten,            
<a name="l00056"></a>00056         LB_BlendDarken,     
<a name="l00057"></a>00057         LB_BlendMultiply,
<a name="l00058"></a>00058         LB_BlendAverage,    
<a name="l00059"></a>00059         LB_BlendAdd,
<a name="l00060"></a>00060         LB_BlendSubtract,
<a name="l00061"></a>00061         LB_BlendDifference,
<a name="l00062"></a>00062         LB_BlendNegation,
<a name="l00063"></a>00063         LB_BlendExclusion,
<a name="l00064"></a>00064         LB_BlendScreen,
<a name="l00065"></a>00065         LB_BlendOverlay,
<a name="l00066"></a>00066         LB_BlendSoftLight,
<a name="l00067"></a>00067         LB_BlendHardLight,
<a name="l00068"></a>00068         LB_BlendColorDodge,
<a name="l00069"></a>00069         LB_BlendColorBurn, 
<a name="l00070"></a>00070         LB_BlendLinearDodge,
<a name="l00071"></a>00071         LB_BlendLinearBurn,
<a name="l00072"></a>00072         LB_BlendLinearLight,
<a name="l00073"></a>00073         LB_BlendVividLight,
<a name="l00074"></a>00074         LB_BlendPinLight,
<a name="l00075"></a>00075         LB_BlendHardMix,
<a name="l00076"></a>00076         LB_BlendReflect,
<a name="l00077"></a>00077         LB_BlendGlow,
<a name="l00078"></a>00078         LB_BlendPhoenix,
<a name="l00079"></a>00079         LB_BlendSaturation,
<a name="l00080"></a>00080         LB_BlendColor,
<a name="l00081"></a>00081         LB_BlendLuminosity,
<a name="l00082"></a>00082         LB_MaxBlendModes
<a name="l00083"></a>00083     };
<a name="l00084"></a>00084 
<a name="l00085"></a>00085     <span class="keyword">enum</span> SourceModifier
<a name="l00086"></a>00086     {
<a name="l00087"></a>00087         SM_Invalid = -1,
<a name="l00088"></a>00088         SM_None,
<a name="l00089"></a>00089         SM_Source1Modulate,
<a name="l00090"></a>00090         SM_Source2Modulate,
<a name="l00091"></a>00091         SM_Source1InvModulate,
<a name="l00092"></a>00092         SM_Source2InvModulate,
<a name="l00093"></a>00093         SM_MaxSourceModifiers
<a name="l00094"></a>00094     };
<a name="l00095"></a>00095 
<a name="l00096"></a>00096     <span class="keyword">struct </span>TextureBlend
<a name="l00097"></a>00097     {
<a name="l00098"></a>00098         TextureBlend() : blendMode(LB_Invalid), sourceModifier(SM_Invalid), customNum(0) {}
<a name="l00099"></a>00099 
<a name="l00100"></a>00100         BlendMode blendMode; <span class="comment">//The blend mode to use</span>
<a name="l00101"></a>00101         SourceModifier sourceModifier; <span class="comment">//The source modification to use</span>
<a name="l00102"></a>00102         <span class="keywordtype">int</span> customNum; <span class="comment">// The number of the custom param controlling the source modification</span>
<a name="l00103"></a>00103         <a class="code" href="group__RTShader.html#ga9b50e9cfcf817b897c37fc77e67f1bbf">ParameterPtr</a> modControlParam; <span class="comment">//The parameter controlling the source modification</span>
<a name="l00104"></a>00104     };
<a name="l00105"></a>00105 
<a name="l00106"></a>00106 
<a name="l00108"></a>00108     LayeredBlending();
<a name="l00109"></a>00109 
<a name="l00113"></a>00113     <span class="keyword">virtual</span> <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">Ogre::String</a>&amp; getType                 () <span class="keyword">const</span>;
<a name="l00114"></a>00114 
<a name="l00115"></a>00115 
<a name="l00121"></a>00121     <span class="keywordtype">void</span> setBlendMode(<span class="keywordtype">unsigned</span> <span class="keywordtype">short</span> index, BlendMode mode);
<a name="l00122"></a>00122 
<a name="l00126"></a>00126     BlendMode getBlendMode(<span class="keywordtype">unsigned</span> <span class="keywordtype">short</span> index) <span class="keyword">const</span>;
<a name="l00127"></a>00127 
<a name="l00128"></a>00128     
<a name="l00129"></a>00129 
<a name="l00135"></a>00135     <span class="keywordtype">void</span> setSourceModifier(<span class="keywordtype">unsigned</span> <span class="keywordtype">short</span> index, SourceModifier modType, <span class="keywordtype">int</span> customNum);
<a name="l00136"></a>00136 
<a name="l00143"></a>00143     <span class="keywordtype">bool</span> getSourceModifier(<span class="keywordtype">unsigned</span> <span class="keywordtype">short</span> index, SourceModifier&amp; , <span class="keywordtype">int</span>&amp; customNum) <span class="keyword">const</span>;
<a name="l00144"></a>00144 
<a name="l00148"></a>00148     <span class="keyword">virtual</span> <span class="keywordtype">void</span> copyFrom               (<span class="keyword">const</span> SubRenderState&amp; rhs);
<a name="l00149"></a>00149 
<a name="l00150"></a>00150     <span class="keyword">static</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> Type;
<a name="l00151"></a>00151 
<a name="l00152"></a>00152 <span class="comment">// Protected methods</span>
<a name="l00153"></a>00153 <span class="keyword">protected</span>:
<a name="l00154"></a>00154     
<a name="l00158"></a>00158     <span class="keyword">virtual</span> <span class="keywordtype">bool</span> resolveParameters(ProgramSet* programSet);
<a name="l00159"></a>00159 
<a name="l00163"></a>00163     <span class="keyword">virtual</span> <span class="keywordtype">bool</span> resolveDependencies(<a class="code" href="classOgre_1_1RTShader_1_1ProgramSet.html" title="Container class for shader based programs.">Ogre::RTShader::ProgramSet</a>* programSet);
<a name="l00164"></a>00164 
<a name="l00165"></a>00165 
<a name="l00166"></a>00166     <span class="keyword">virtual</span> <span class="keywordtype">void</span> addPSBlendInvocations(Function* psMain, 
<a name="l00167"></a>00167                                     <a class="code" href="group__RTShader.html#ga9b50e9cfcf817b897c37fc77e67f1bbf">ParameterPtr</a> arg1,
<a name="l00168"></a>00168                                     <a class="code" href="group__RTShader.html#ga9b50e9cfcf817b897c37fc77e67f1bbf">ParameterPtr</a> arg2,
<a name="l00169"></a>00169                                     <a class="code" href="group__RTShader.html#ga9b50e9cfcf817b897c37fc77e67f1bbf">ParameterPtr</a> texel,
<a name="l00170"></a>00170                                     <span class="keywordtype">int</span> samplerIndex,
<a name="l00171"></a>00171                                     <span class="keyword">const</span> LayerBlendModeEx&amp; blendMode,
<a name="l00172"></a>00172                                     <span class="keyword">const</span> <span class="keywordtype">int</span> groupOrder, 
<a name="l00173"></a>00173                                     <span class="keywordtype">int</span>&amp; internalCounter,
<a name="l00174"></a>00174                                     <span class="keywordtype">int</span> targetChannels);
<a name="l00179"></a>00179     <span class="keywordtype">void</span> addPSModifierInvocation(Function* psMain, 
<a name="l00180"></a>00180                                 <span class="keywordtype">int</span> samplerIndex, 
<a name="l00181"></a>00181                                 <a class="code" href="group__RTShader.html#ga9b50e9cfcf817b897c37fc77e67f1bbf">ParameterPtr</a> arg1,
<a name="l00182"></a>00182                                 <a class="code" href="group__RTShader.html#ga9b50e9cfcf817b897c37fc77e67f1bbf">ParameterPtr</a> arg2,
<a name="l00183"></a>00183                                 <span class="keyword">const</span> <span class="keywordtype">int</span> groupOrder, 
<a name="l00184"></a>00184                                 <span class="keywordtype">int</span>&amp; internalCounter,
<a name="l00185"></a>00185                                 <span class="keywordtype">int</span> targetChannels);
<a name="l00186"></a>00186 
<a name="l00187"></a>00187     <span class="comment">// Attributes.</span>
<a name="l00188"></a>00188 <span class="keyword">protected</span>:
<a name="l00189"></a>00189     vector&lt;TextureBlend&gt;::type mTextureBlends;
<a name="l00190"></a>00190 
<a name="l00191"></a>00191 };
<a name="l00192"></a>00192 
<a name="l00193"></a>00193 
<a name="l00194"></a>00194 
<a name="l00199"></a>00199 <span class="keyword">class </span>LayeredBlendingFactory : <span class="keyword">public</span> SubRenderStateFactory
<a name="l00200"></a>00200 {
<a name="l00201"></a>00201 <span class="keyword">public</span>:
<a name="l00202"></a>00202 
<a name="l00206"></a>00206     <span class="keyword">virtual</span> <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp;   getType             () <span class="keyword">const</span>;
<a name="l00207"></a>00207 
<a name="l00211"></a>00211     <span class="keyword">virtual</span> SubRenderState* createInstance      (ScriptCompiler* compiler, PropertyAbstractNode* prop, TextureUnitState* texState, SGScriptTranslator* translator);
<a name="l00212"></a>00212 
<a name="l00216"></a>00216     <span class="keyword">virtual</span> <span class="keywordtype">void</span>            writeInstance       (MaterialSerializer* ser, SubRenderState* subRenderState, <span class="keyword">const</span> TextureUnitState* srcTextureUnit, <span class="keyword">const</span> TextureUnitState* dstTextureUnit);
<a name="l00217"></a>00217 
<a name="l00218"></a>00218     
<a name="l00219"></a>00219 <span class="keyword">protected</span>:
<a name="l00220"></a>00220 
<a name="l00224"></a>00224     <span class="keyword">virtual</span> SubRenderState* createInstanceImpl  ();
<a name="l00225"></a>00225 
<a name="l00229"></a>00229     LayeredBlending::BlendMode stringToBlendMode(<span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> &amp;strValue);
<a name="l00233"></a>00233     <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> blendModeToString(LayeredBlending::BlendMode blendMode);
<a name="l00234"></a>00234 
<a name="l00238"></a>00238     LayeredBlending::SourceModifier stringToSourceModifier(<span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> &amp;strValue);
<a name="l00239"></a>00239     
<a name="l00243"></a>00243     <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> sourceModifierToString(LayeredBlending::SourceModifier modifier);
<a name="l00244"></a>00244 
<a name="l00250"></a>00250     LayeredBlending* createOrRetrieveSubRenderState(SGScriptTranslator* translator);
<a name="l00251"></a>00251 };
<a name="l00252"></a>00252 
<a name="l00253"></a>00253 }
<a name="l00254"></a>00254 }
<a name="l00255"></a>00255 
<a name="l00256"></a>00256 <span class="preprocessor">#endif</span>
<a name="l00257"></a>00257 <span class="preprocessor"></span><span class="preprocessor">#endif</span>
</pre></div></div><!-- contents -->
<hr>
<p>
Copyright &copy; 2012 Torus Knot Software Ltd<br />
<!--Creative Commons License--><a rel="license" href="http://creativecommons.org/licenses/by-sa/3.0/"><img alt="Creative Commons License" style="border-width:0" src="http://i.creativecommons.org/l/by-sa/3.0/88x31.png" /></a><br />This work is licensed under a <a rel="license" href="http://creativecommons.org/licenses/by-sa/3.0/">Creative Commons Attribution-ShareAlike 3.0 Unported License</a>.<br/>
		<!--/Creative Commons License--><!-- <rdf:RDF xmlns="http://web.resource.org/cc/" xmlns:dc="http://purl.org/dc/elements/1.1/" xmlns:rdf="http://www.w3.org/1999/02/22-rdf-syntax-ns#">
		<Work rdf:about="">
			<license rdf:resource="http://creativecommons.org/licenses/by-sa/2.5/" />
	<dc:type rdf:resource="http://purl.org/dc/dcmitype/Text" />
		</Work>
		<License rdf:about="http://creativecommons.org/licenses/by-sa/2.5/"><permits rdf:resource="http://web.resource.org/cc/Reproduction"/><permits rdf:resource="http://web.resource.org/cc/Distribution"/><requires rdf:resource="http://web.resource.org/cc/Notice"/><requires rdf:resource="http://web.resource.org/cc/Attribution"/><permits rdf:resource="http://web.resource.org/cc/DerivativeWorks"/><requires rdf:resource="http://web.resource.org/cc/ShareAlike"/></License></rdf:RDF> -->

Last modified Fri May 25 2012 21:48:51
</p>
</body>
</html>
